ad_library {
    Procs for creating and manipulating a captcha image.

    @author Cesar Claveria (cesar@viaro.net)
    @creation-date 2006-12-12

}


#loads  TclMagick
package require TclMagick
namespace eval captcha {}

ad_proc -public captcha::create {} {
 Creates a captcha image and returns the id for the captcha.
 @author Cesar Claveria (cesar@viaro.net)
 @creation-date 2006-12-12
} {
set serverroot [acs_root_dir]

#creates new wand and draw objects
    set wand [magick create wand]
    set draw [magick create draw]
#randomly selects a background file
    set number_files [clock clicks] 
    set bg_no [expr {int(rand()*$number_files)} % 9 + 1] 

#loads the background image to the wand objetc and resize it 
   $wand ReadImage  $serverroot/packages/acs-subsite/www/shared/captchas/captcha$bg_no.jpg
   $wand ResizeImage 280 90 cubic

#Proc to Generate an hexadecimal color string, something like 55CA23, only the # sign is missing
    proc lpick L {lindex $L [expr {int(rand()*[llength $L])}]}
    proc random_string_color { length {chars {0 1 2 3 4 5 6 7 8 9 A B C D E F }} } {
	for {set i 0} {$i<$length} {incr i} {append res [lpick $chars]}
    return "#$res"
    }

#set some coordinates variables to place the letters.
set an_x [expr {int(rand()*5)} + 30]
set an_y [expr {int(rand()*5)} + 25]

set where_y [expr int(rand()*15)]
set where_x [expr int(rand()*5)]

set offset_x [expr int(rand()*5)]
set offset_y [expr int(rand()*5)]


#in this for we generate the actual text.
set captcha_text ""
    for {set i 0} {$i < 6} {incr i} {
   #lets generate the captcha 1 char at the time.
	set captcha_char [string toupper [ad_generate_random_string 0]]


	#We begin writing, or drawing letters actually, to the image.
	$draw push graph
	 set pixel [magick create pixel]
	 set fill  [magick create pixel]
	 $pixel color [random_string_color 6]
 	 $wand border $pixel
	 $fill color  [random_string_color 6]
	 $draw SetStrokeWidth [expr int(rand()*5)+1]
	 $draw SetStrokeColor $fill
	 $draw SetFillColor   $fill
	 $draw SetFontSize [expr int(rand()*20)+25]
	 set where_x [expr $an_x + $offset_x]
	 set where_y [expr $an_y + $offset_y]
   	 if { $where_y > 88} {
	     set where_y [expr [expr $where_y % 49] + 25]
	 }

	 $draw Annotation $where_x $where_y  $captcha_char
	 append captcha_text $captcha_char
  
       $draw pop graph
       #$draw Rotate [expr {int(rand()*45)}]
       set offset_x [expr {int(rand()*10)} + $offset_x + 30 - {int(rand()*5)}]
       set offset_y [expr {int(rand()*10)} + $offset_y - {int(rand()*5)} + 20]
	

    }


$wand DrawImage $draw

#Saves the image in jpg format
    set captcha_file_name  captcha[ad_generate_random_string 6].jpg 
    $wand WriteImage $serverroot/packages/acs-subsite/www/shared/captchas/$captcha_file_name



#delete the wand and draw objects
magick delete $draw
magick delete $wand
set ct_encrypted [ ns_sha1 $captcha_text]

#we schudele the file deletion to 2 minutes after it was created.
ad_schedule_proc -once t 120 captcha::delete $captcha_file_name
#We return the id of the captcha, not the filename, use captcha::get_filename to get the file name.

return [list "/shared/captchas/$captcha_file_name" "$ct_encrypted" ] 

}

ad_proc -public captcha::delete {
file_name
} {
    
    Deletes a captcha image based on the filename
} {
   set serverroot [acs_root_dir]
   file delete $serverroot/packages/acs-subsite/www/shared/captchas/$file_name
 
}

